package RTC;


/**
* RTC/DataFlowComponentActionOperations.java .
* IDL-to-Java\u30b3\u30f3\u30d1\u30a4\u30e9(\u30dd\u30fc\u30bf\u30d6\u30eb)\u3001\u30d0\u30fc\u30b8\u30e7\u30f3"3.2"\u306b\u3088\u3063\u3066\u751f\u6210\u3055\u308c\u307e\u3057\u305f
* idl/LogicalTimeTriggeredEC.idl\u304b\u3089
* 2016\u5e7411\u67081\u65e5 15\u664208\u520620\u79d2 JST
*/


/*!
   * @if jp
   * @brief 
   * @else
   * @brief DataFlowComponentAction
   *
   * @section Description
   *
   * DataFlowComponentAction is a companion to ComponentAction (see
   * Section 5.2.2.4) that provides additional callbacks for
   * intercepting the two execution passes defined in Section
   * 5.3.1.1.2.
   *
   * @endif
   */
public interface DataFlowComponentActionOperations 
{

  /*!
       * @if jp
       * @brief 
       * @else
       * @brief on_execute
       * @section Description
       *
       * This operation will be invoked periodically at the rate of the
       * given execution context as long as the following conditions
       * hold:
       *
       * - The RTC is Active.
       *
       * - The given execution context is Running.
       *
       * @section Semantics
       *
       This callback occurs during the first execution pass.
       *
       * @section Constraints
       *
       * - The execution context of the given context shall be PERIODIC.
       *
       * @endif
       */
  RTC.ReturnCode_t on_execute (int exec_handle);

  /*!
       * @if jp
       * @brief 
       * @else
       * @brief on_state_update
       *
       * @section Description
       *
       * This operation will be invoked periodically at the rate of the
       * given execution context as long as the following conditions hold:
       *
       * - The RTC is Active.
       *
       * - The given execution context is Running.
       *
       * @section Semantics
       *
       * This callback occurs during the second execution pass.
       *
       * @section Constraints
       *
       * - The execution context of the given context shall be PERIODIC.
       *
       *
       * @endif
       */
  RTC.ReturnCode_t on_state_update (int exec_handle);

  /*!
       * @if jp
       * @brief 
       * @else
       * @brief on_rate_changed
       *
       * @section Description
       *
       * This operation is a notification that the rate of the indicated
       * execution context (see Section 5.2.2.6.4) has changed.
       *
       * @section Constraints
       *
       * - The execution context of the given context shall be PERIODIC.
       *
       *
       * @endif
       */
  RTC.ReturnCode_t on_rate_changed (int exec_handle);
} // interface DataFlowComponentActionOperations
