package RTC;


/**
* RTC/_FsmServiceStub.java .
* IDL-to-Java\u30b3\u30f3\u30d1\u30a4\u30e9(\u30dd\u30fc\u30bf\u30d6\u30eb)\u3001\u30d0\u30fc\u30b8\u30e7\u30f3"3.2"\u306b\u3088\u3063\u3066\u751f\u6210\u3055\u308c\u307e\u3057\u305f
* idl/LogicalTimeTriggeredEC.idl\u304b\u3089
* 2016\u5e7411\u67081\u65e5 15\u664208\u520620\u79d2 JST
*/


/*!
   * @if jp
   * @brief 
   * @else
   * @brief FsmService
   *
   * @section Description
   *
   * The FsmService interface defines operations necessary for
   * Stimulus Response Processing as an SDO service.
   *
   * @endif
   */
public class _FsmServiceStub extends org.omg.CORBA.portable.ObjectImpl implements RTC.FsmService
{


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief get_fsm_profile
       *
       * @section Description
       *
       * Get the current state of the FSM.
       *
       * @section Semantics
       *
       * Modifications to the object returned by this operation will not
       * be reflected in the FSM until and unless set_fsm_profile is
       * called.
       *
       * @endif
       */
  public RTC.FsmProfile get_fsm_profile ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_fsm_profile", true);
                $in = _invoke ($out);
                RTC.FsmProfile $result = RTC.FsmProfileHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_fsm_profile (        );
            } finally {
                _releaseReply ($in);
            }
  } // get_fsm_profile


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief set_fsm_profile
       *
       * @section Description
       *
       * This operation will be used to modify the behavior of an FSM as
       * described in Stimulus Response Processing.
       *
       * @endif
       */
  public RTC.ReturnCode_t set_fsm_profile (RTC.FsmProfile fsm_profile)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("set_fsm_profile", true);
                RTC.FsmProfileHelper.write ($out, fsm_profile);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return set_fsm_profile (fsm_profile        );
            } finally {
                _releaseReply ($in);
            }
  } // set_fsm_profile

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:omg.org/RTC/FsmService:1.0", 
    "IDL:org.omg/SDOPackage/SDOService:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init (args, props);
   try {
     org.omg.CORBA.Object obj = orb.string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
   } finally {
     orb.destroy() ;
   }
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init (args, props);
   try {
     String str = orb.object_to_string (this);
     s.writeUTF (str);
   } finally {
     orb.destroy() ;
   }
  }
} // class _FsmServiceStub
